std::unordered_multimap::end,(3)

NAME
std::unordered_multimap::end, - std::unordered_multimap::end,

Synopsis
   iterator end() noexcept; (since C++11)
   const_iterator end() const noexcept; (since C++11)
   const_iterator cend() const noexcept; (since C++11)
   Returns an iterator to the element following the last element of the
   unordered_multimap.
   This element acts as a placeholder; attempting to access it results in undefined
   behavior.
   range-begin-end.svg

Parameters
   (none)

Return value
   Iterator to the element following the last element.

Complexity
   Constant.

Example
// Run this code
 #include <unordered_map>
 #include <algorithm>
 #include <cassert>
 #include <iostream>
 #include <string>
 #include <utility>
 int main()
 {
     auto show_node = [](const std::pair<std::string, std::string>& node) {
         std::cout << node.first << " : " << node.second << '\n';
     };
     std::unordered_multimap<std::string, std::string> lemmas;
     assert(lemmas.begin() == lemmas.end()); // OK
     assert(lemmas.cbegin() == lemmas.cend()); // OK
     lemmas.insert({ "1. ∀x ∈ N ∃y ∈ N", "x ≤ y" });
     show_node(*lemmas.cbegin());
     assert(lemmas.begin() != lemmas.end()); // OK
     assert(lemmas.cbegin() != lemmas.cend()); // OK
     lemmas.begin()->second = "x < y";
     show_node(*lemmas.cbegin());
     lemmas.insert({ "2. ∀x,y ∈ N", "x = y V x ≠ y" });
     show_node(*lemmas.cbegin());
     lemmas.insert({ "3. ∀x ∈ N ∃y ∈ N", "y = x + 1" });
     show_node(*lemmas.cbegin());
     std::cout << "lemmas: \n";
     std::for_each(lemmas.cbegin(), lemmas.cend(),
         [&](const auto& n) { show_node(n); });
     std::cout << "\n";
 }

Possible output:
 1. ∀x ∈ N ∃y ∈ N : x ≤ y
 1. ∀x ∈ N ∃y ∈ N : x < y
 2. ∀x,y ∈ N : x = y V x ≠ y
 3. ∀x ∈ N ∃y ∈ N : y = x + 1
 lemmas:
 3. ∀x ∈ N ∃y ∈ N : y = x + 1
 1. ∀x ∈ N ∃y ∈ N : x < y
 2. ∀x,y ∈ N : x = y V x ≠ y

See also
   begin returns an iterator to the beginning
   cbegin (public member function)
   (C++11)
   end
   cend returns an iterator to the end of a container or array
   (C++11) (function template)
   (C++14)